<template>
  <v-row>
    <v-col cols="12" sm="4" md="3">
      <Field #default="{ errors, field, value }" name="Atr" :immediate="!!pax.id" rules="max:20" v-model="pax.atr">
        <v-text-field @update:model-value="field.onChange" :model-value="value" label="ATR" data-cy="PaxFormAtrInput"
          density="compact" :error-messages="errors" variant="outlined">
        </v-text-field>
      </Field>
    </v-col>
    <v-col cols="12" sm="4" md="3">
      <Field #default="{ errors, field, value }" :immediate="!!pax.id" name="Departure" v-model="pax.departure">
        <airport-picker @update:model-value="field.onChange" :model-value="value" label="Départ"
          data-cy="PaxFormDepartureInput" density="compact" :items="airportsDeparture"
          :item-title="(airport: Airport) => `${airport.oaci}${airport.name ? ' - ' + airport.name : ''}`" return-object
          variant="outlined" :error-messages="errors.concat(legsError)">
        </airport-picker>
      </Field>
    </v-col>
    <v-col cols="12" sm="4" md="3">
      <Field #default="{ errors, field, value }" :immediate="!!pax.id" name="Arrival" rules="required"
        v-model="pax.arrival">
        <airport-picker @update:model-value="field.onChange" :model-value="value" label="Arrivée"
          data-cy="PaxFormArrivalInput" density="compact" class="required" :items="airportsArrival"
          :item-title="(airport: Airport) => `${airport.oaci}${airport.name ? ' - ' + airport.name : ''}`" return-object
          variant="outlined" :error-messages="errors.concat(legsError)">
        </airport-picker>
      </Field>
    </v-col>


    <v-col cols="12" sm="4" md="3">
      <Field #default="{ errors, field, value }" :immediate="!!pax.id" name="Number" rules="integer|between:1,999"
        v-model="pax.number">
        <v-text-field @update:model-value="field.onChange" :model-value="value" label="PAX Nbr"
          data-cy="PaxFormNbrInput" density="compact" type="number" :error-messages="errors" variant="outlined">
        </v-text-field>
      </Field>
    </v-col>
    <v-col cols="12" sm="4" md="3">
      <Field #default="{ errors, field, value }" :immediate="!!pax.id" name="Weight"
        rules="required|decimal|between:0,999" v-model="pax.weight">
        <v-text-field @update:model-value="field.onChange" :model-value="value" label="Poids"
          data-cy="PaxFormWeightInput" density="compact" type="number" :error-messages="errors" variant="outlined" class="required">
        </v-text-field>
      </Field>
    </v-col>
    <v-col cols="12" sm="4" md="3">
      <Field #default="{ errors, field, value }" :immediate="!!pax.id" name="LuggageWeight"
        rules="decimal|between:0,9999" v-model="pax.luggageWeight">
        <v-text-field @update:model-value="field.onChange" :model-value="value" label="Poids Bagage"
          data-cy="PaxFormLuggageWeightInput" density="compact" type="number" :error-messages="errors" variant="outlined">
        </v-text-field>
      </Field>
    </v-col>

    <v-col cols="12" sm="4" md="3">
      <Field #default="{ errors, field, value }" :immediate="!!pax.id" name="Gender" rules="max:50"
        v-model="pax.gender">
        <v-text-field @update:model-value="field.onChange" :model-value="value" label="Genre"
          data-cy="PaxFormGenderInput" density="compact" :error-messages="errors" variant="outlined">
        </v-text-field>
      </Field>
    </v-col>
    <v-col cols="12" sm="4" md="3">
      <Field #default="{ errors, field, value }" :immediate="!!pax.id" name="LastName" rules="required|max:50"
        v-model="pax.lastName">
        <v-text-field @update:model-value="field.onChange" :model-value="value" label="Nom"
          data-cy="PaxFormLastnameInput" density="compact" :error-messages="errors" variant="outlined" class="required">
        </v-text-field>
      </Field>
    </v-col>
    <v-col cols="12" sm="4" md="3">
      <Field #default="{ errors, field, value }" :immediate="!!pax.id" name="FirstName" rules="required|max:50"
        v-model="pax.firstName">
        <v-text-field @update:model-value="field.onChange" :model-value="value" label="Prénom"
          data-cy="PaxFormFirstnameInput" density="compact" :error-messages="errors" variant="outlined" class="required">
        </v-text-field>
      </Field>
    </v-col>

    <v-col cols="12" sm="4" md="3">
      <Field #default="{ errors, field, value }" :immediate="!!pax.id" name="Rank" rules="required" v-model="pax.rank">
        <v-autocomplete @update:model-value="field.onChange" :model-value="value" label="Grade"
          data-cy="PaxFormRankInput" density="compact" :error-messages="errors" class="required" :items="ranks"
          :item-title="(rank: Rank) => rank.name + ' - ' + rank.category" variant="outlined" return-object>
        </v-autocomplete>
      </Field>
    </v-col>
    <v-col cols="12" sm="4" md="3">
      <Field #default="{ errors, field, value }" :immediate="!!pax.id" name="Category" rules="max:50"
        v-model="pax.category">
        <v-text-field @update:model-value="field.onChange" :model-value="value" label="Catégorie"
          data-cy="PaxFormCategoryInput" density="compact" :error-messages="errors" variant="outlined">
        </v-text-field>
      </Field>
    </v-col>
    <v-col cols="12" sm="4" md="3">
      <Field #default="{ errors, field, value }" :immediate="!!pax.id" name="MilitaryId" rules="max:50"
        v-model="pax.militaryId">
        <v-text-field @update:model-value="field.onChange" :model-value="value" label="ID Militaire"
          data-cy="PaxFormMilitaryIdInput" density="compact" :error-messages="errors" variant="outlined">
        </v-text-field>
      </Field>
    </v-col>

    <v-col cols="12" sm="4" md="3">
      <Field #default="{ errors, field, value }" :immediate="!!pax.id" name="Birthdate" rules="max:50"
        v-model="pax.birthdate">
        <v-text-field @update:model-value="field.onChange" :model-value="value" label="Date de naissance"
          data-cy="PaxFormBirthdateInput" density="compact" :error-messages="errors" variant="outlined">
        </v-text-field>
      </Field>
    </v-col>
    <v-col cols="12" sm="4" md="3">
      <Field #default="{ errors, field, value }" :immediate="!!pax.id" name="Unit" rules="required|max:50"
        v-model="pax.unit">
        <v-text-field @update:model-value="field.onChange" :model-value="value" label="Unité" data-cy="PaxFormUnitInput"
          density="compact" :error-messages="errors" class="required" variant="outlined">
        </v-text-field>
      </Field>
    </v-col>
    <v-col cols="12" sm="4" md="3">
      <Field #default="{ errors, field, value }" :immediate="!!pax.id" name="Nationality" rules="required|max:50"
        v-model="pax.nationality">
        <v-text-field @update:model-value="field.onChange" :model-value="value" label="Nationalité"
          data-cy="PaxFormNationalityInput" density="compact" :error-messages="errors" variant="outlined" class="required">
        </v-text-field>
      </Field>
    </v-col>

    <v-col cols="12" sm="4" md="3">
      <Field #default="{ errors, field, value }" :immediate="!!pax.id" name="Observations" rules="max:255"
        v-model="pax.observations">
        <v-text-field @update:model-value="field.onChange" :model-value="value" label="Observations"
          data-cy="PaxFormObservationsInput" density="compact" :error-messages="errors" variant="outlined">
        </v-text-field>
      </Field>
    </v-col>

    <v-col cols="12" sm="4" v-show="false">
      <Field #default="{ errors, field, value }" :immediate="!!pax.id" name="Legs" rules="required" v-model="pax.legs">
        <v-text-field @update:model-value="field.onChange" :model-value="value" label="Legs" density="compact"
          :error-messages="errors" class="required" variant="outlined">
        </v-text-field>
      </Field>
    </v-col>
  </v-row>
</template>

<script setup lang="ts">
import moment from "moment";
import { Pax } from "~/dto/pax.dto";
import { Leg } from "~/dto/leg.dto";
import { Rank } from "~/dto/rank.dto";
import { debounce } from "~/components/mixins/utilsMixin";
import { Airport } from "~/dto/airport.dto";

const props = defineProps<{
  pax: Pax,
  legs: Leg[]
}>();

const store = useStore();

const legsError: Ref<string[]> = ref([]);
const formBis: Ref<any> = ref(null);
const ranks: Ref<Rank[]> = computed(() => {
  return store.ranksLight;
});
const airportsDeparture: Ref<Airport[]> = computed(() => {
  return store.airportsEnabled.filter((a: Airport) => props.legs.map(l => l.departure.id).includes(a.id));
});
const airportsArrival: Ref<Airport[]> = computed(() => {
  return store.airportsEnabled.filter((a: Airport) => props.legs.map(l => l.arrival.id).includes(a.id));
});

const affectLegs = () => {
  const legs = [];
  let idxStart = 0;
  if (props.pax.departure) {
    const idx = props.legs.findIndex(l => l.departure.id === props.pax.departure.id);
    idxStart = idx >= 0 ? idx : 0;
  }
  if (props.pax.departure && props.pax.arrival) {
    const idx = props.legs.findIndex(l => l.arrival.id === props.pax.arrival.id);
    for (let i = idxStart; i <= idx; i++) {
      legs.push(props.legs[i]);
    }
  }
  props.pax.legs = legs;
  affectLegsError();
}

const computeUnderage = () => {
  if (['ENFANT', 'BB'].includes(props.pax.rank?.name)) {
    return true;
  }
  if (props.pax.birthdate && moment(props.pax.birthdate, 'DD/MM/YYYY').isValid()) {
    const years = moment().diff(props.pax.birthdate, 'years', true);
    return years < 18;
  }
  return false;
}

const affectLegsError = async () => {
  await formBis.value.validate();
  if (formBis.value?.errors?.Legs && formBis.value?.errors.Legs.length > 0) {
    legsError.value = ['Aucun Leg ne correspond aux données rentrées'];
  } else {
    legsError.value = [];
  }
}

onMounted(() => {
  if (props.pax.id) {
    affectLegsError();
  }
})

watch(() => props.pax.departure, debounce(function () {
  affectLegs();
}, 100));

watch(() => props.pax.arrival, debounce(function () {
  affectLegs();
}, 100));

watch(() => props.pax.birthdate, debounce(function () {
  computeUnderage();
}, 100));

watch(() => props.pax.rank, debounce(function () {
  computeUnderage();
}, 100));
</script>
